/**
 * @private
 **/
export declare class Animation {
    private _parent;
    private _c;
    private _el;
    private _opts;
    private _fx;
    private _dur;
    private _easing;
    private _bfSty;
    private _bfAdd;
    private _bfRmv;
    private _afSty;
    private _afAdd;
    private _afRmv;
    private _pFns;
    private _fFns;
    private _fOnceFns;
    private _wChg;
    private _rv;
    private _unregTrans;
    private _tmr;
    isPlaying: boolean;
    hasTween: boolean;
    meta: any;
    constructor(ele?: any, opts?: AnimationOptions);
    _reset(): void;
    element(ele: any): Animation;
    parent(parentAnimation: Animation): Animation;
    add(childAnimation: Animation): Animation;
    getDuration(): number;
    duration(milliseconds: number): Animation;
    getEasing(): string;
    easing(name: string): Animation;
    from(prop: string, val: any): Animation;
    to(prop: string, val: any): Animation;
    fromTo(prop: string, fromVal: any, toVal: any): Animation;
    private _addProp(state, prop, val);
    fadeIn(): Animation;
    fadeOut(): Animation;
    before: {
        addClass: (className: string) => Animation;
        removeClass: (className: string) => Animation;
        setStyles: (styles: any) => Animation;
    };
    after: {
        addClass: (className: string) => Animation;
        removeClass: (className: string) => Animation;
        setStyles: (styles: any) => Animation;
    };
    play(opts?: PlayOptions): void;
    stop(opts?: PlayOptions): void;
    _asyncEnd(duration: number): void;
    _clearAsync(): void;
    _progress(stepValue: number): void;
    _setTrans(duration: number, forcedLinearEasing: any): void;
    _willChange(addWillChange: boolean): void;
    _before(): void;
    _after(): void;
    progressStart(): void;
    progressStep(stepValue: number): void;
    progressEnd(shouldComplete: boolean, currentStepValue: number): void;
    onPlay(callback: Function): this;
    onFinish(callback: Function, onceTimeCallback?: boolean, clearOnFinishCallacks?: boolean): this;
    _onFinish(): void;
    reverse(shouldReverse?: boolean): this;
    destroy(removeElement?: boolean): void;
    _transEl(): HTMLElement;
    static create(name: string, opts?: AnimationOptions): Animation;
    static register(name: string, AnimationClass: any): void;
}
export interface AnimationOptions {
    animation?: string;
    renderDelay?: number;
}
export interface PlayOptions {
    duration?: number;
    stepValue?: number;
}
