import { Menu } from './menu';
import { SlideEdgeGesture } from '../../gestures/slide-edge-gesture';
/**
 * Gesture attached to the content which the menu is assigned to
 */
export declare class MenuContentGesture extends SlideEdgeGesture {
    menu: Menu;
    constructor(menu: Menu, contentEle: HTMLElement, options?: any);
    canStart(ev: any): boolean;
    onSlideBeforeStart(slide: any, ev: any): void;
    onSlide(slide: any, ev: any): void;
    onSlideEnd(slide: any, ev: any): void;
    getElementStartPos(slide: any, ev: any): any;
    getSlideBoundaries(): {
        min: number;
        max: number;
    };
}
/**
 * Gesture attached to the actual menu itself
 */
export declare class MenuTargetGesture extends MenuContentGesture {
    constructor(menu: Menu, menuEle: HTMLElement);
}
